using System;
using System.Data;
using System.Data.Odbc;
using System.Windows.Forms;
using System.Drawing;

namespace Microblue.Other.Odbc
{
  class OdbcDlg : Form
  {
    Label    lblTable;
    TextBox  tbxConn;
    TextBox  tbxSql;
    Button   btnSubmit;
    Button   btnStru;
    DataGrid dgOut;
    string strConn = "DSN=icbcdb;Uid=icbcdb;Pwd=hzb";

    public OdbcDlg()
    {
      SuspendLayout();
      
      btnStru = new Button();
      btnStru.Text = "ṹ";
      btnStru.Location = new Point(10, 420);
      btnStru.Size = new Size(60, 24);
      btnStru.Click += new EventHandler(Stru_Click);
      btnStru.Anchor = (AnchorStyles.Bottom | AnchorStyles.Left);

      btnSubmit = new Button();
      btnSubmit.Text = "ѯ";
      btnSubmit.Location = new Point(80, 420);
      btnSubmit.Size = new Size(60, 24);
      btnSubmit.Click += new EventHandler(Submit_Click);
      btnSubmit.Anchor = (AnchorStyles.Bottom | AnchorStyles.Left);

      lblTable = new Label();
      lblTable.Text = "Դ";
      lblTable.Location = new Point(12, 460);
      lblTable.Size = new Size(70, 24);
      lblTable.Anchor = (AnchorStyles.Bottom | AnchorStyles.Left);

      tbxConn = new TextBox();
      tbxConn.Text = strConn;
      tbxConn.Location = new Point(83, 456);
      tbxConn.Size = new Size(626, 20);
      tbxConn.Anchor = (AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right);

      tbxSql = new TextBox();
      tbxSql.Text = "select *\r\nfrom ctrl\r\n";
      tbxSql.Location = new Point(10, 10);
      tbxSql.Size = new Size(240, 400);
      tbxSql.Multiline = true;
      tbxSql.ScrollBars = ScrollBars.Both;
      tbxSql.AcceptsReturn = true;
      tbxSql.WordWrap = true;
      tbxSql.Anchor = (AnchorStyles.Top | AnchorStyles.Bottom | AnchorStyles.Left);

      dgOut = new DataGrid();
      dgOut.Location = new Point(260, 10);
      dgOut.Size = new Size(450, 436);
      dgOut.CaptionVisible = false;
      dgOut.Anchor = (AnchorStyles.Top | AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right);

      Controls.AddRange(new Control[]{btnSubmit, btnStru, lblTable, tbxSql, tbxConn, dgOut});
      Text = "ݿѯ(ODBC)";
      ClientSize = new Size(720, 490);

      ResumeLayout(false);
    }
    
    void DisplayError(Exception ex)
    {
      string s = ex.Message;
      OdbcException e = ex as OdbcException;
      if (e != null)
      {
        s += "\n";
        for (int i = 0; i < e.Errors.Count; i++) s += string.Format(
          "Index: {0}\nMessage: {1}\nNativeError: {2}\nSource: {3}\nSQLState: {4}\n",
          i, e.Errors[i].Message, e.Errors[i].NativeError, e.Errors[i].Source, e.Errors[i].SQLState
        );
      }
      MessageBox.Show(s);
    }

    void Submit_Click(object sender, EventArgs e)
    {
      string sql = tbxSql.Text;
      try
      {
        OdbcDataAdapter cmd = new OdbcDataAdapter(sql, tbxConn.Text);
        DataSet d =new DataSet();
        cmd.Fill(d, "aaa");
        dgOut.DataSource = d.Tables["aaa"].DefaultView;
        dgOut.ReadOnly = true;
      }
      catch (Exception ex)
      {
        DisplayError(ex);
      }
    }

    void Stru_Click(object sender, EventArgs e)
    {
      string sql = tbxSql.Text;
      try
      {
        OdbcConnection conn = new OdbcConnection(tbxConn.Text);
        conn.Open();
        OdbcCommand comm = new OdbcCommand(sql, conn);
        OdbcDataReader r = comm.ExecuteReader();
        DataTable dt = new DataTable();
        dt.Columns.Add("", typeof(string));
        dt.Columns.Add("Դ", typeof(string));
        dt.Columns.Add("ֶ", typeof(string));
        for (int i = 0; i < r.FieldCount; i++)
        {
          DataRow dr = dt.NewRow();
          dr[0] = r.GetFieldType(i);
          dr[1] = r.GetDataTypeName(i);
          dr[2] = r.GetName(i);
          dt.Rows.Add(dr);
        }
        r.Close();
        conn.Close();
        dgOut.DataSource = dt.DefaultView;
        dgOut.ReadOnly = true;
      }
      catch (Exception ex)
      {
        DisplayError(ex);
      }
    }

    static void Main()
    {
      Application.Run(new OdbcDlg());
    }
  }
}
