using System;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Windows.Forms;
using System.Drawing;

namespace Skyiv.Util.SqlClient
{
  class SqlDlg : Form
  {
    Label    lblTable;
    TextBox  tbxConn;
    TextBox  tbxSql;
    TextBox  tbxMsg;
    Button   btnSubmit;
    CheckBox chkStru;
    DataGrid dgOut;
    string strConn = "server=.\\SQLEXPRESS;database=master;Integrated Security=SSPI";

    public SqlDlg()
    {
      SuspendLayout();
      
      btnSubmit = new Button();
      btnSubmit.Text = "ִ";
      btnSubmit.Location = new Point(10, 420);
      btnSubmit.Size = new Size(60, 24);
      btnSubmit.Click += new EventHandler(Submit_Click);
      btnSubmit.Anchor = (AnchorStyles.Bottom | AnchorStyles.Left);

      chkStru = new CheckBox();
      chkStru.Text = "ṹ";
      chkStru.Location = new Point(80, 420);
      chkStru.Size = new Size(60, 24);
      chkStru.Anchor = (AnchorStyles.Bottom | AnchorStyles.Left);

      lblTable = new Label();
      lblTable.Text = "Դ";
      lblTable.Location = new Point(12, 460);
      lblTable.Size = new Size(70, 24);
      lblTable.Anchor = (AnchorStyles.Bottom | AnchorStyles.Left);

      tbxConn = new TextBox();
      tbxConn.Text = strConn;
      tbxConn.Location = new Point(83, 456);
      tbxConn.Size = new Size(626, 20);
      tbxConn.Anchor = (AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right);

      tbxSql = new TextBox();
      tbxSql.Text = "select @@version";
      tbxSql.Location = new Point(10, 10);
      tbxSql.Size = new Size(240, 200);
      tbxSql.Multiline = true;
      tbxSql.ScrollBars = ScrollBars.Both;
      tbxSql.AcceptsReturn = true;
      tbxSql.WordWrap = true;
      tbxSql.Anchor = (AnchorStyles.Top | AnchorStyles.Left);

      tbxMsg = new TextBox();
      tbxMsg.Location = new Point(10, 220);
      tbxMsg.Size = new Size(240, 190);
      tbxMsg.Multiline = true;
      tbxMsg.ScrollBars = ScrollBars.Both;
      tbxMsg.AcceptsReturn = true;
      tbxMsg.WordWrap = true;
      tbxMsg.Anchor = (AnchorStyles.Top | AnchorStyles.Bottom | AnchorStyles.Left);

      dgOut = new DataGrid();
      dgOut.Location = new Point(260, 10);
      dgOut.Size = new Size(450, 436);
      dgOut.CaptionVisible = false;
      dgOut.ReadOnly = true;
      dgOut.Anchor = (AnchorStyles.Top | AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right);

      Controls.AddRange(new Control[]{btnSubmit, chkStru, lblTable, tbxSql, tbxMsg, tbxConn, dgOut});
      Text = "ݿѯ(SqlClient)";
      ClientSize = new Size(720, 490);
      WindowState = FormWindowState.Maximized;

      ResumeLayout(false);
    }
    
    void DisplayError(Exception ex)
    {
      StringBuilder sb = new StringBuilder();
      while (ex != null)
      {
        sb.Append("> ");
        sb.Append(ex.GetType());
        sb.Append(Environment.NewLine);
        SqlException e = ex as SqlException;
        if (e != null)
        {
          for (int i = 0; i < e.Errors.Count; i++) sb.AppendFormat(
            "Index: {1}{0}Message: {2}{0}Source: {3}{0}", Environment.NewLine,
            i, e.Errors[i].Message, e.Errors[i].Source
          );
        }
        else sb.Append(ex.Message);
        sb.Append(Environment.NewLine);
        ex = ex.InnerException;
      }
      tbxMsg.Text = sb.ToString();
    }

    void Submit_Click(object sender, EventArgs e)
    {
      btnSubmit.Enabled = false;
      string sql = tbxSql.Text.Trim();
      if (sql.Length == 0) return;
      try
      {
        int rows = -2;
        string strType = "ѯ";
        using (SqlConnection conn = new SqlConnection(tbxConn.Text))
        {
          conn.Open();
          SqlCommand comm = new SqlCommand(sql, conn);
          if (!isQuery(sql))
          {
            strType = "ǲѯ";
            rows = comm.ExecuteNonQuery();
          }
          else if (chkStru.Checked)
          {
            strType = "ṹ";
            dgOut.DataSource = RunQueryTableStruct(comm);
          }
          else dgOut.DataSource = RunQueryTableData(comm);
        }
        tbxMsg.Text = " SQL (" + strType + ")";
        if (rows >= 0) tbxMsg.Text = "Ӱ: " + rows.ToString("N0");
      }
      catch (Exception ex)
      {
        DisplayError(ex);
      }
      btnSubmit.Enabled = true;
    }
    
    bool isQuery(string sql)
    {
      return sql.Substring(0, 6).ToUpper() == "SELECT";
    }
    
    private DataView RunQueryTableData(SqlCommand comm)
    {
      SqlDataAdapter da = new SqlDataAdapter();
      da.SelectCommand = comm;
      DataSet ds = new DataSet();
      da.Fill(ds);
      return ds.Tables[0].DefaultView;
    }

    private DataView RunQueryTableStruct(SqlCommand comm)
    {
      DataTable dt = new DataTable();
      dt.Columns.Add("#", typeof(int));
      dt.Columns.Add("ֶ", typeof(string));
      dt.Columns.Add("", typeof(string));
      dt.Columns.Add("Դ", typeof(string));
      dt.Columns.Add("С", typeof(string));
      dt.Columns.Add("ע", typeof(string));
      using (SqlDataReader r = comm.ExecuteReader(CommandBehavior.KeyInfo))
      {
        DataTable dt0 = r.GetSchemaTable();
        // return dt0.DefaultView;
        foreach (DataRow dr0 in dt0.Rows)
        {
          DataRow dr = dt.NewRow();
          dr[0] = (int)dr0["ColumnOrdinal"];
          dr[1] = (string)dr0["ColumnName"];
          dr[2] = GetBriefType(dr0["DataType"]);
          dr[3] = ((SqlDbType)dr0["ProviderType"]).ToString();
          dr[4] = string.Format(
            "({0},{1}) {2}", (short)dr0["NumericPrecision"], (short)dr0["NumericScale"], (int)dr0["ColumnSize"]
            );
          dr[5] = string.Format(
            "{0}{1}{2}{3}{4}{5}{6}{7}{8}{9}{10}",
            (bool)dr0["AllowDBNull"    ] ? "AllowDBNull "   : "",
            (bool)dr0["IsKey"          ] ? "Key "           : "",
            (bool)dr0["IsIdentity"     ] ? "Identity "      : "",
            (bool)dr0["IsAutoIncrement"] ? "AutoIncrement " : "",
            (bool)dr0["IsUnique"       ] ? "Unique "        : "",
            (bool)dr0["IsExpression"   ] ? "Expression "    : "",
            (bool)dr0["IsAliased"      ] ? "Aliased "       : "",
            (bool)dr0["IsRowVersion"   ] ? "RowVersion "    : "",
            (bool)dr0["IsHidden"       ] ? "Hidden "        : "",
            (bool)dr0["IsLong"         ] ? "Long "          : "",
            (bool)dr0["IsReadOnly"     ] ? "ReadOnly "      : ""
          );
          dt.Rows.Add(dr);
        }
      }
      return dt.DefaultView;
    }
    
    string GetBriefType(object obj)
    {
      string s = (obj as Type).ToString();
      if (string.CompareOrdinal(s, 0, "System.", 0, 7) == 0) s = s.Substring(7);
      return s;
    }

    static void Main()
    {
      Application.Run(new SqlDlg());
    }
  }
}
